/*
 *  1.16.      , 
 *       ;  
 *      .
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define DECIMAL_POINT   '.'
#define MEM_CHUNK_SIZE  16

char *ftoa(double num, unsigned DecimalPlaces);

int main()
{
  double num;
  int dp;
  char *str;

  fputs("Enter a FP number: ", stdout);
  scanf("%lf", &num);
  fputs("Enter number of decimal places: ", stdout);
  scanf("%u", &dp);

  if ( !(str = ftoa(num, dp)) ) {
    puts("Error converting the number.");
    return -1;
  }

  puts(str);

  return 0;
}



int CheckBufferSize(char **str, int *len, int cur);
char* strrev(char *str, unsigned n);

char *ftoa(double num, unsigned DecimalPlaces)
{
  char *str;
  int len, i, sgn;
  double IntPart, FracPart;

  /* Allocate initial memory chunk */
  if ( !(str = (char *) malloc(MEM_CHUNK_SIZE)) )
    return NULL;
  len = MEM_CHUNK_SIZE;
  i = 0;
  /* Save sign and store absolute value in num */
  if ( num < 0 ) {
    sgn = 1;
    num = -num;
  } else
    sgn = 0;
  /* Split up num in integer and fractional parts */
  FracPart = modf(num, &IntPart);

  /* Get integer part (in reversed order) */
  while ( IntPart >= 1 ) {
    *(str + i++) = '0' + (char) fmod(IntPart, 10);
    IntPart = IntPart / 10;
    if ( !CheckBufferSize(&str, &len, i) )
      return NULL;
  }
  /* Add sign if necessary */
  if (sgn) {
    *(str + i++) = '-';
    if ( !CheckBufferSize(&str, &len, i) )
      return NULL;
  }
  strrev(str, i);

  /* Add decimal point if necessary */
  if ( DecimalPlaces ) {
    *(str + i++) = DECIMAL_POINT;
    if ( !CheckBufferSize(&str, &len, i) )
      return NULL;
  }
  /* Get fractional part */
  while ( DecimalPlaces-- ) {
    IntPart = FracPart * 10;
    *(str + i++) = '0' + (char) IntPart;
    FracPart = modf(IntPart, &IntPart);
    if ( !CheckBufferSize(&str, &len, i) )
      return NULL;
  }

  /* Terminate the string */
  *(str + i) = '\0';

  return str;
}

/* Grows buffer if necessary.  If reallocation fails, frees the
 * original buffer.  Returns buffer length on success, zero on
 * failure. */
int CheckBufferSize(char **str, int *len, int cur)
{
  char *tmp;

  if ( cur >= *len ) {
    *len += MEM_CHUNK_SIZE;
    if ( tmp = (char *) realloc(*str, *len ) ) {
      *str = tmp;
      return *len;
    }
    else {
      free(*str);
      return 0;
    }
  }

  return *len;
}

char *strrev(char *str, unsigned n)
{
  char *rev, c;

  if ( !str )
    return NULL;

  rev = str + n - 1;
  while ( rev > str ) {
    c = *rev;
    *rev-- = *str;
    *str++ = c;
  }

  return str;
}




/*
 * Local variables:
 * compile-command: "gcc -lm 1_16.c && ./a.out <<< '5.84 3'"
 * End:
 */
