#include "fp.h"

tnodeptr MakeNode(int type, long value)
{
  tnodeptr ptrNode;

  if ( !( ptrNode = (tnodeptr) malloc( sizeof(tnode) ) ) ) {
    fputs(strErrMem, stderr);
    return NULL;
  }

  ptrNode->type = type;
  ptrNode->value = value;
  ptrNode->ptrLeft = ptrNode->ptrRight = NULL;

  return ptrNode;
}

void FreeTreeMem(tnodeptr ptrRoot)
{
  if (!ptrRoot)
    return;

  FreeTreeMem(ptrRoot->ptrLeft);
  FreeTreeMem(ptrRoot->ptrRight);
  free((void *) ptrRoot);
}

static void SpaceOut(int level)
{
  int i;

  for ( i = 0; i < level; i++ )
    putchar(' ');
}

static void PrintNode(tnodeptr ptrRoot, int level, char LR)
{
  SpaceOut(level);
  printf("%c%d: ", LR, level);
  if ( ptrRoot->type == NT_NUMBER )
    printf("%d\n", ptrRoot->value);
  else
    printf("%c\n", (Operations+ptrRoot->value)->code);
}

static void _PrintOutTree(tnodeptr ptrRoot, int level, char LR)
{
  if ( !ptrRoot )
    return;

  PrintNode(ptrRoot, level, LR);
  if (ptrRoot->ptrLeft)
    _PrintOutTree(ptrRoot->ptrLeft, level+1, 'L');
  if (ptrRoot->ptrRight)
    _PrintOutTree(ptrRoot->ptrRight, level+1, 'R');
}

void PrintOutTree(tnodeptr ptrRoot)
{
  _PrintOutTree(ptrRoot, 0, 'O');
}


/*
 * Local variables:
 * compile-command: "make -k all && echo && ./fp fp.in"
 * End:
 */
