/*
 *  6.5.    A_1, A_2, ..., A_n.     
 *   ,   A_1, A_2, ..., A_n.
 */

#include <stdio.h>
#include <stdlib.h>

#define IN_BUFFER_LEN           20

typedef struct _litem {
  int value;
  struct _litem *ptrNext;
} litem, *litemptr; 

int  iout(int n, int pos);
void PrintOutList(litemptr ptrHead);
void FreeListMem(litemptr ptrHead);

int main(void)
{
  int i, *InBuf, ret = 0;
  litemptr ptrHead, ptrNew, ptrTemp;

  /* Allocate and fill in the array */
  if ( !( InBuf = (int *) malloc(IN_BUFFER_LEN*sizeof(*InBuf)) ) )
    return -1;
  srand(time(0));
  for ( i = 0; i < IN_BUFFER_LEN; i++ )
    *(InBuf + i) = rand() / (RAND_MAX / 10);

  /* Print out array */
  for ( i = 0; i < IN_BUFFER_LEN; i++ )
    printf("%d ", *(InBuf + i));

  putchar('\n');

  /* Allocate memory for the list head */
  if ( !(ptrHead = (litemptr) malloc(sizeof(litem))) )
    return -1;

  ptrHead->value = *InBuf;
  ptrHead->ptrNext = NULL;

  for ( i = 1; i < IN_BUFFER_LEN; i++ ) {
    int arr_el = *(InBuf + i);

    if ( arr_el < ptrHead->value ) {
      /* Add new list item before the head */
      if ( !(ptrNew = (litemptr) malloc(sizeof(litem))) ) {
        ret = -1;
        break;
      }
      ptrNew->value = arr_el;
      ptrNew->ptrNext = ptrHead;
      ptrHead = ptrNew;
    } else if ( arr_el > ptrHead->value ) { /* Need this IF to get rid of
                                         `arr_el == ptrHead->value' situation */
      ptrTemp = ptrHead;
      /* Search through the list until we reach the end or until we see that
         next item is greater than arr_el */
      while ( ptrTemp->ptrNext && ptrTemp->ptrNext->value < arr_el )
        ptrTemp = ptrTemp->ptrNext;
      /* Add new list item if we reached the end of list or next item is not
         equal to arr_el (i.e. greater than arr_el) */
      if ( !ptrTemp->ptrNext || ptrTemp->ptrNext->value != arr_el ) {
        if ( !(ptrNew = (litemptr) malloc(sizeof(litem))) ) {
          ret = -1;
          break;
        }
        ptrNew->value = arr_el;
        ptrNew->ptrNext = ptrTemp->ptrNext;
        ptrTemp->ptrNext = ptrNew;
      }
    }
  }

  PrintOutList(ptrHead);

  FreeListMem(ptrHead);

  return ret;
}

void PrintOutList(litemptr ptrHead)
{
  while ( ptrHead ) {
    printf("%d ", ptrHead->value);
    ptrHead = ptrHead->ptrNext;
  }

  putchar('\n');

  return;
}

void FreeListMem(litemptr ptrHead)
{
  litemptr ptrNext;

  while ( ptrHead ) {
    ptrNext = ptrHead->ptrNext;
    free( (void *) ptrHead );
    ptrHead = ptrNext;
  }

  return;
}



/*
 * Local variables:
 * compile-command: "gcc 6_05.c && echo && ./a.out"
 * End:
 */
