/*
 *  6.16.      MxN; 
 * ()       .
 *    .
 */

#include <stdio.h>
#include <stdlib.h>

#define M       10
#define N       3

double **matrix;

void MatrixOut(void);

int main(void)
{
  int i, j, k, gotcha;
  double curr;
  double *ptrTemp;


  /* Seed the pseudo-number generator */
  srand(time(0));
  if ( !(matrix = (double **) malloc(sizeof(double *) * M)) )
    return -1;
  /* Allocate space for and fill in the matrix (last element in each row will
     hold the sum of that row) */
  for ( i = 0; i < M; i++) {
    if ( !( ptrTemp = (double *) malloc(sizeof(double) * (N + 1)) ) )
      return -1;
    *(matrix + i) = ptrTemp;
    for ( j = 0; j < N; j++ )
      *(ptrTemp + j) = (double) ( rand() / (RAND_MAX / 10) );
  }

  /* Calculate column sums and display matrix and sums */
  for ( i = 0; i < M; i++ ) {
    ptrTemp = *(matrix + i);
    for ( j = 0; j < N; j++)
      *(ptrTemp + N) += *(ptrTemp + j);
  }
  fputs("Original matrix:\n\n", stdout);
  MatrixOut();

  /* Sort the rows in non-ascending order */
  for ( i = M - 1, gotcha = -1; i > 0 && gotcha; i-- ) {
    gotcha = 0;
    /* Bubble up the row with largest sum */
    for ( j = 0; j < i; j++ ) {
      k = j++;
      curr = *(*(matrix + k) + N);
      /* Scan rows until current sum is >= than consequent ones */
      while ( j <= i && curr >= *(*(matrix + j) + N) )
        j++;
      j--; /* Return back */
      if ( k != j ) {
        /* Swap the rows */
        ptrTemp = *(matrix + k);
        *(matrix + k) = *(matrix + j);
        *(matrix + j) = ptrTemp;
        gotcha = -1;
      }
    }
  }

  fputs("\n\nSorted matrix:\n\n", stdout);
  MatrixOut();
  putchar('\n');

  return 0;
}

void MatrixOut(void)
{
  int i, j;

  /* Print the transposed matrix */
  for ( j = 0; j < N; j++ ) {
    for ( i = 0; i < M; i++)
      printf("%3.0lf", *(*(matrix + i) + j));
    putchar('\n');
  }
  for ( j = 0; j < 3 * M; j++ )
    putchar('-');
  putchar('\n');
  /* Print the sums */
  for ( i = 0; i < M; i++)
    printf("%3.0lf", *(*(matrix + i) + N));
}



/*
 * Local variables:
 * compile-command: "gcc 6_16.c && echo && ./a.out"
 * End:
 */
