/*
 *  7.5.   A  B--, k-- .   , 
 *  A  B  k-, 
 * 1)     A  B  k ,    k 
 *     ..   ;    (
 *    )   , ..   k , 
 *          A  B    
 *    ;
 * 2)     A     
 *     B     ;
 * 3)          1,   , 
 *            .
 *
 *    k-     g  h
 * ,     2k-.
 */

#include <stdio.h>

const char *FileNameIn1  = "7_05.1.in";
const char *FileNameIn2  = "7_05.2.in";
const char *FileNameOut1 = "7_05.1.out";
const char *FileNameOut2 = "7_05.2.out";
long k = 5;                                    /* length of k-groups */


int main(void)
{
  FILE *fin1, *fin2, *fout1, *fout2, *ftemp;
  int   val1, val2;                             /* vars to read stuff into */
  int   val1_read, val2_read;                   /* read error flags */
  long  count1, count2;                         /* count of output elements */
  long  two_k = k + k;                          /* length of 2k-group */

  /* Try and open the files */
  if ( !(fin1 = fopen(FileNameIn1,"r")) || !(fin2 = fopen(FileNameIn2,"r")) )
    return -1;
  if ( !(fout1 = fopen(FileNameOut1,"w")) || !(fout2 = fopen(FileNameOut2,"w")) )
    return -1;

  val1_read = fscanf(fin1, "%d", &val1);
  val2_read = fscanf(fin2, "%d", &val2);

  while ( val1_read != EOF || val2_read != EOF ) {
    count1 = count2 = 0;

    /* Output sorted 2k-group to out-file No1 by mixing one k-group from 1st
       in-file with another k-group from 2nd in-file  */
    while ( ( val1_read != EOF || val2_read != EOF ) &&   /* anything left... */
            count1 + count2 < two_k ) {  /* ... and 2k-group not finished yet */

      if ( ( val2_read == EOF ||                /* 2nd file is done for */
             count2 >= k      ||                /* k-group from 2nd file done */
             val1 <= val2 && count1 < k ) &&    /* sorted order */
           val1_read != EOF ) {                 /* anything been read */
        fprintf(fout1, "%d\n", val1);
        count1++;
        val1_read = fscanf(fin1, "%d", &val1);

        continue;
      }

      if ( ( val1_read == EOF ||                /* 1st file is done for */
             count1 >= k      ||                /* k-group from 1st file done */
             val2 <= val1 && count2 < k ) &&    /* sorted order */
           val2_read != EOF ) {                 /* anything been read */
        fprintf(fout1, "%d\n", val2);
        count2++;
        val2_read = fscanf(fin2, "%d", &val2);
      }
    }

    /* Separate 2k-groups by a newline */
    putc('\n', fout1);
    /* Switch to the other file for next 2k-group output */
    ftemp = fout1, fout1 = fout2, fout2 = ftemp;
  }

  fclose(fin1);
  fclose(fin2);
  fclose(fout1);
  fclose(fout2);

  return 0;
}



/*
 * Local variables:
 * compile-command: "gcc 7_05.c && echo && ./a.out"
 * End:
 */
