/*
 * Problem A.
 */
#include <stdio.h>
#include <stdlib.h>


int  n;
int *pic;
int check_figure(int i, int j, int k);


int main(void)
{
  int  max_half_size, i, j, k, n_minus_one, n_minus_two;
  int *row;

  while ( 1 ) {
    /* Get picture dimensions */
    scanf("%d", &n);
    if ( n == 0 )
      break;
    n_minus_one = n - 1;
    n_minus_two = n_minus_one - 1;

    /* Get picture */
    pic = (int *) malloc( sizeof(int) * n * n );
    for ( i = 0; i < n * n; i++ )
      scanf("%d", pic + i );

    max_half_size = 0;

    /* Main loop--search for the first white cell, this will be a candidate for
       an upper vertex of white square inside the figure we are looking for.  No
       use to check first and last columns and two last rows--they cannot
       contain the upper vertex we are looking for.  */
    for ( i = 0; i < n_minus_two; i++ ) {
      row = pic + i * n;
      for ( j = 1; j < n_minus_one; j++ ) {
        if ( !*(row + j ) ) {
          /* Now, go left and right from this vertex, `expanding' width of the
             candidate figure, as long as we do not hit the border or we have no
             more black cells both to the left and to the right of this vertex.
             In each step check whether we got our figure.  If we did not, try
             to `expand' the width more; if we did, record its width and
             break--there is no use `expanding' further, we will not get any
             more figures because it would have to contain the one we found,
             which is impossible.  */
          for ( k = 1; *(row+ j-k) && *(row+ j+k) && j-k >= 0 && j+k < n; k++ )
            if ( check_figure(i, j, k) ) {
              if ( k > max_half_size )
                max_half_size = k;
              j += k; /* skip right after the figure */
              break;
            }
        }
      }
    }

    if ( max_half_size )
      printf("%d\n", max_half_size * 2 + 1);
    else
      puts("No solution");

    free(pic);
  }

  return 0;
}

int check_figure(int vertex_i, int vertex_j, int half_size)
{
  int i, j;
  int *row_vertex;

  /* Check vertical width does not violate the border (no use to check
     horizontal width--it has been done in the main loop) */
  if ( vertex_i + half_size * 2 + 1 > n )
    return 0;

  /* Check upper half of the figure (center line included).  Do not check the
     first line--it has been checked in the main loop) */
  for ( i = 1; i <= half_size; i++ ) {
    row_vertex = pic + (vertex_i + i) * n + vertex_j;
    /* Check white cells are there */
    for ( j = 0; j <= i; j++ )
      if ( *(row_vertex + j) || *(row_vertex - j) )
        return 0;
    /* Check black cells are there */
    for ( j = half_size; j > i; j-- )
      if ( *(row_vertex + j) != 1 || *(row_vertex - j) != 1 )
        return 0;
  }

  /* Check lower half of the figure (center line excluded) */
  for ( i = 1; i <= half_size; i++ ) {
    row_vertex = pic + (vertex_i + half_size + i) * n + vertex_j;
    /* Check white cells are there */
    for ( j = 0; j <= half_size - i; j++ )
      if ( *(row_vertex + j) != 0 || *(row_vertex - j) != 0 )
        return 0;
    /* Check black cells are there */
    for ( j = half_size; j > half_size - i; j-- )
      if ( *(row_vertex + j) != 1 || *(row_vertex - j) != 1 )
        return 0;
  }

  return -1;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall a.c && ./a.out < a.in"
 * End:
 */
