/*
 * Problem D.
 */
#include <stdio.h>
#include <stdlib.h>

#define MEM_ALLOC_CHUNK     10

int **lists;
int  *already_out;
int  *sorted;
int   sorted_count;
int   n;


void find_descendents(int martian);


int main(void)
{
  int i, j, len, temp;

  scanf("%d", &n);

  lists       = (int **) malloc( sizeof(int *) * n );
  already_out = (int *)  malloc( sizeof(int)   * n );
  sorted      = (int *)  malloc( sizeof(int)   * n );

  /* Enter the lists */
  for ( i = 0; i < n; i++ ) {
    len = 0;
    j   = 0;
    *(lists + i) = NULL;
    *(already_out + i) = 0;
    do {
      scanf("%d", &temp);
      /* Grow list if necessary */
      while ( len <= j ) {
        len += MEM_ALLOC_CHUNK;
        *(lists + i) = (int *) realloc((void *) *(lists + i), len*sizeof(**lists));
      }
      *(*(lists + i) + j++) = temp;
    } while ( temp );
  }

  /* Main loop */
  sorted_count = 0;
  for ( i = 0; i < n && sorted_count < n; i++ )
    find_descendents(i);

  /* Output the sorted list of members (it is in reverse order) */
  for ( i = n - 1; i > 0; i-- )
    printf("%d ", *(sorted + i) + 1);
  printf("%d", *sorted + 1);

  return 0;
}


void find_descendents(int martian)
{
  int j = 0;

  /* First, recursively output all descendents, if any */
  while ( *(*(lists + martian) + j) )
    find_descendents( *(*(lists + martian) + j++) - 1 );

  /* Now, output this Martian if he (she? it?) is not yet out */
  if ( !*(already_out + martian) ) {
    *(already_out + martian)   = -1;
    *(sorted + sorted_count++) = martian;
  }

  return;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall d.c && ./a.out <<< \"5   0   4 5 1 0   1 0   5 3 0   3 0\""
 * End:
 */
