/*
 * Problem F.
 */
#include <stdio.h>
#include <stdlib.h>


typedef struct _TSpan {
  int s;
  int e;
} TSpan, *ptrTSpan;


int      n;
ptrTSpan ttbl;
int      count;


int main(void)
{
  int   i, j, bubbled_up;
  TSpan tspan;

  /* Get time-table length */
  scanf("%d", &n);

  /* Allocate buffers */
  ttbl = (ptrTSpan) malloc( sizeof(TSpan) * n );

  /* Enter time-table */
  for ( i = 0; i < n; i++ )
    scanf("%d%d", &(ttbl + i)->s, &(ttbl + i)->e);

  /* Sort time-table by start time */
  for ( i = 0; i < n; i++ ) {
    bubbled_up = 0;
    for ( j = i + 1; j < n; j++ )
      if ( (ttbl+i)->s > (ttbl+j)->s ) {
        tspan       = *(ttbl + i);
        *(ttbl + i) = *(ttbl + j);
        *(ttbl + j) = tspan;
        bubbled_up  = -1;
      }
    if ( !bubbled_up )
      break;
  }

  /* Main loop.  What we do is we find the sequence of `optimal' time intervals.
     The idea behind the algorithm for finding this sequence is as follows
     (array of intervals is assumed to be sorted by start time):

     1. make first interval current;
     2. make current interval a candidate for next optimal interval (OptInt);
     3. search forward for an interval starting and ending before OptInt ends;
     4. if no such interval found, go to step 5; else make the interval we found
        an OptInt and go to step 3;
     5. fix current OptInt; skip all intervals which do not start after the
        fixed OptInt; go to step 2;
  */
  count = 0;
  i     = 0;
  while ( i < n ) {
    /* Find OptInt */
    for ( j = i + 1; j < n && (ttbl + j)->s < (ttbl + i)->e; j++ )
      if ( (ttbl + j)->e < (ttbl + i)->e )
        i = j;
    /* Another interval found--increment counter */
    count++;
    /* Skip until intervals starting after the interval we found ends */
    while ( j < n && (ttbl + j)->s <= (ttbl + i)->e )
      j++;
    i = j;
  }

  printf("%d\n", count);

  return 0;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall f.c && ./a.out <<<\"5  3 4  1 5  6 7  4 5  1 3\""
 * End:
 */
