/*
 * Problem G.
 */
#include <stdio.h>
#include <stdlib.h>

int  k;
int  len;
int *result;
int *scratch;

int main(void)
{
  int i, j, carry;

  scanf("%d", &k);

  /* Length for result buffer:  36 * 55^{k-1} < 100 * 100^{k-1} = 10^{2k} */
  len     = k + k;
  result  = (int *) malloc( sizeof(*result)  * len );
  /* We could make scratch buffer length one less than result buffer length, but
     algorithm below will write 0 to this extra buffer element, so leave it as
     it is */
  scratch = (int *) malloc( sizeof(*scratch) * len );

  *result       = 6;
  *(result + 1) = 3;
  j             = 2;

  while ( --k ) {
    /* Multiply result buffer by 5 saving it in scratch buffer */
    carry = 0;
    for ( i = 0; i < j; i++ ) {
      *(scratch + i) = *(result + i) * 5 + carry;
      if ( *(scratch + i) >= 10 ) {
        carry = *(scratch + i) / 10;
        *(scratch + i) %= 10;
      } else
        carry = 0;
    }
    if ( carry )
      *(scratch + i++) = carry;

    /* Add scratch buffer to itself shifted one digit saving it in result
       buffer */
    *(scratch + i) = 0; /* we have reserved this extra element (see above) */
    *result = *scratch;
    carry   = 0;
    for ( j = 1; j <= i; j++ ) {
      *(result + j) = *(scratch + j) + *(scratch + j - 1) + carry;
      if ( *(result + j) >= 10 ) {
        carry = *(result + j) / 10;
        *(result + j) %= 10;
      } else
        carry = 0;
    }
    if ( carry )
      *(result + j++) = carry;
  }

  /* Print out the result */
  for ( i = j - 1; i >= 0; i-- )
    putchar(*(result + i) + '0');
  putchar('\n');

  return 0;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall g.c && ./a.out <<< 5"
 * End:
 */
