/*
 * Problem I.
 */
#include <stdio.h>
#include <stdlib.h>

unsigned long **blocks;
char outbuffer[15];

int main(void)
{
  int n, i, j, k;
  int carry, nonzero;
  unsigned long *ptr, *cur;

  scanf("%d", &n);

  /* Allocate a `triangular' 2-D buffer.  In this buffer, i-th element is
     pointer to the vector of numbers of staircases we can build of i bricks.
     j-th element in this vector is number of staircases we can build of i
     bricks if we use up j bricks for the highest step. */
  blocks = (unsigned long **) malloc( sizeof(*blocks) * n );
  for ( i = 0; i < n; i++ )
    *(blocks + i) = (unsigned long *) malloc( sizeof(**blocks) * (i + 1) );

  /* Fill the buffer up, calculating the vectors for i bricks on the basis of
     the vectors we already have filled in for i-1, i-2, ..., 1 bricks. */
  for ( i = 0; i < n; i++ ) {  /* take from 1 to n bricks */
    **(blocks + i) = 0;        /* no staircases with step of height 1 (for the
                                  very first staircase of 1 brick, this will be
                                  changed to 1, see below) */
    for ( j = 1; j < i; j++ ) {/* use from 1 to i - 1 bricks for the highest
                                  step and calculate how many staircases we can
                                  build below this step from remaining bricks */
      cur  = *(blocks + i) + j;
      *cur = 0;                /* zero the counter */
      ptr  = *(blocks + i - j - 1); /* (i - j) is number of bricks left, so look
                                       in (i - j)-th vector */
      /* Add up the staircases we can build with remaining bricks */
      k = j - 1; /* Start with step one brick lower than the highest step but */
      if ( k > i - j - 1 ) /* make sure there are enough bricks left for step */
        k = i - j - 1;     /* of such height (we have (i-j) bricks left).     */
      for ( ; k >= 0; k-- )
        *cur += *(ptr + k);
    }
    *(*(blocks + i) + i) = 1;   /* Though we cannot build a staircase with just
                                   one stair of i bricks, make this 1 so that
                                   future staircases would include such step */
  }

  /* Add up numbers in n-th vector */
  i = n - 1;
  k = 0;
  carry = 0;
  do {
    nonzero = 0;
    for ( j = n - 2; j >= 0; j-- )    /* don't count last element (see above) */
      if ( *(*(blocks + i) + j) ) {
        nonzero = -1;
        carry += *(*(blocks + i) + j) % 10;
        *(*(blocks + i) + j) /= 10;
      }
    *(outbuffer + k++) = carry % 10;
    carry /= 10;
  } while ( nonzero && carry );
  while ( carry ) {
    *(outbuffer + k++) = carry % 10;
    carry /= 10;
  }

  /* Print out the total */
  for ( j = k - 1; j >= 0; j-- )
    printf("%d", (int) *(outbuffer + j));
  putchar('\n');

  return 0;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall i.c && ./a.out <<< 212"
 * End:
 */
