/*
 * Non-recursive algorithm for finding all permutations of first N natural
 * numbers.
 */
#include <stdio.h>
#include <stdlib.h>

#define SWAP(a, b, tmp)      tmp = a; a = b; b = tmp

int n;
int *permutation;
int *withdrawn;

void print_out(void);

int main(void)
{
  int i, j, tmp;

  /* Get array length */
  scanf("%d", &n);

  /* Allocate buffers */
  permutation = (int *) malloc( sizeof(*permutation) * n );
  withdrawn   = (int *) malloc( sizeof(*withdrawn) * n );
  for ( i = 0; i < n; i++ ) {
    *(permutation + i) = i;
    *(withdrawn     + i) = i;
  }

  /* Main loop.  The idea is the same as in recursive algorithm (see
     recursive_permutations.c).  Addresses of withdrawn elements are recorded in
     `withdrawn' buffer; we need them to be able to restore elements back to
     their original positions after we have done all permutations with the rest
     of the array. */
  j = n - 1;
  while ( 1 ) {
    if ( j == n - 1 ) {
      print_out();
      j--;
    }
    if ( *(withdrawn + j) == n - 1 ) {
      if ( j == 0 ) /* All done */
        break;

      /* Move the withdrawn element back into place */
      tmp                    = *(permutation + j);
      *(permutation + j)     = *(permutation + n - 1);
      *(permutation + n - 1) = tmp;

      *(withdrawn + j) = j;
      j--;
    } else {
      /* Move the withdrawn element back into place */
      tmp                               = *(permutation + *(withdrawn + j));
      *(permutation + *(withdrawn + j)) = *(permutation + j);

      (*(withdrawn + j))++;

      /* Withdraw next element */
      *(permutation + j)                = *(permutation + *(withdrawn + j));
      *(permutation + *(withdrawn + j)) = tmp;

      j = n - 1;
    }
  }

  return 0;
}

void print_out(void)
{
  int i, n_minus_one = n - 1;

  for ( i = 0; i < n_minus_one; i++ )
    printf("%d ", *(permutation + i) + 1);
  printf("%d\n", *(permutation + i) + 1);

  return;
}



/*
 * Local variables:
 * compile-command: "gcc -Wall permutations.c && ./a.out <<< 5"
 * End:
 */
