/*
 * Prints out all permutations of integers in the range 1 to n inclusive.
 * Uses recursion.
 */

#include <stdio.h>
#include <stdlib.h>

int *ptrHead, n;

void permutation(int i);

int main(void)
{
  int i;

/*   fputs("Enter N: ", stdout); */
  scanf("%d", &n);
  if ( !(ptrHead = (int *) malloc (n * sizeof(*ptrHead))) )
       return -1;
  for ( i = 0; i < n; i++ )
    *(ptrHead + i) = i;

  permutation(0);

  return 0;
}

void permutation(int i)
{
  int j, temp, i_plus_one = i + 1;

  /* If we reached the end of the array, print out next permutation */
  if ( i == n - 1 ) {
    int n_minus_one = n - 1;
    for ( j = 0; j < n_minus_one; j++ )
      printf("%d ", *(ptrHead+j) + 1);
    printf("%d\n", *(ptrHead+j) + 1);

    return;
  }

  /* Switch first element with each consecutive element, calling recursively
     permutation function for each of the combinations (after each call switch
     the elements back into place) */
  permutation(i_plus_one);
  for ( j = i_plus_one; j < n; j++ ) {
    temp = *(ptrHead+i); *(ptrHead+i) = *(ptrHead+j); *(ptrHead+j) = temp;
    permutation(i_plus_one);
    temp = *(ptrHead+i); *(ptrHead+i) = *(ptrHead+j); *(ptrHead+j) = temp;
  }

  return;
}


/*
 * Local variables:
 * compile-command: "gcc recursive_permutations.c && echo && ./a.out <<< 5"
 * End:
 */
